# AutoItemPickup

Automatically grants items on the ground to players when the teleport is initiated or an item spawns.

NOTE: Please check out the config options in `BepInEx/config/com.kuberoot.autoitempickup.cfg` before usage. Distributing items on drop is *disabled by default.*

[Support me on Ko-fi](https://ko-fi.com/kuberoot)

## Features:

-   Distributing on item drop and/or teleport
-   Can grant items to dead players
-   Server-only - the mod does not need to be installed on clients
-   Filtering by item tier, ignores lunar items by default
-   By default items from printers/cauldrons/similar go to the activator upon distribution, as long as the activator is still a valid target
-   Items can be blacklisted from pickup individually, using a comma-separated config entry. Items can be blacklisted by english name (EN_US locale) or ItemIndex name. For example:
    -   `ItemBlacklist = Bustling Fungus, Syringe, Infusion, BleedOnHit, Backup Magazine`
-   Features 4 distribution modes:
    -   `Sequential` - Grants one item to each player, looping over players when they run out, roughly equally distributed
    -   `Random` - Distributes items randomly
    -   `Closest` - Grants each item to the nearest player
    -   `LeastItems` - Grants each item to the player with least items of its rarity
-   Enabling `TeleportCommandCubes` makes selection cubes teleport to you or the teleporter
    -   TL;DR: Enable this for limited distribution when playing with Command
    -   If distributing items on drop is enabled and the item that would've dropped matches the config, the command drop is teleported to the appropriate player using the distributor.
        -   NOTE: The LeastItems distributor does not care about command cubes that have been teleported to a player but haven't yet been picked up, so they might pool up at one player
    -   If distributing items on teleport is enabled, the command drops whose items would've matched the config will teleport around the teleporter with those conditions:
        -   When the teleporter finishes charging, all matching command drops will teleport around the teleporter.
        -   If the teleporter finished charging and an item matches the on teleport config but not the on drop config, the command drops will teleport around the teleporter.

## Installation

Copy the `AutoItemPickup` folder to `Risk of Rain 2/BepInEx/plugins`

## Patch notes:

- 1.6.1
    - Fix error when giving items to dead players
    - Fix error with `Closest` distributor when distributing to dead players is enabled and some players are dead
    - Fix off-by-one issues with selecting random players, affecting mostly random distribution, that would prevent the last player from getting items
    - Add support in code for unloading the mod at runtime
    - The `Sequential` distributor will now try to preserve the current target when a player joins or leaves
- 1.6.0 - Update to RoR2 Survivors of the Void
    - Teleporting command essences on teleport will now space them away from the center of the teleporter
- 1.4.3 - Update to RoR2 1.0 update
    - Remove code to snap command cubes to the ground, since they now have gravity
- 1.4.2 - Hotfix: Fix error when distributing command cubes if the stage doesn't have a teleporter
- 1.4.1 - Fixes for Command
    - Items chosen from command cubes go to the person selecting the item
    - Command cubes that are moved when the teleporter finishes charging are now properly synchronised for clients
- 1.4.0 - Update to RoR2 Artifacts update
    - Added `TeleportCommandCubes` for simple Artifact of Command compatibility
- 1.3.2 - Update to RoR2 Skills 2.0 update
- 1.3.1 - Update to RoR2 Scorched Acres update
- 1.3.0 - Update to BepInExPack 2.0.0 and R2API 2.0.6; no changes to function.
- 1.2.1 - Fixed error related to changes in language handling in latest RoR2 update (Build #3830295)
- 1.2.0 - Added item blacklisting, separate for drop and teleport.
- 1.1.4 - Fixed missing UpdateTargets condition, which caused `Closest` distributor to throw after first stage. Added additional exception handling in distributor to avoid interfering with game code.
- 1.1.3 - Fixed `Closest` distribution mode throwing exceptions and preventing teleportation when dead players are not ignored and a player is dead
- 1.1.2 - Fixed `Closest` distribution mode presumably being completely broken, without actually testing to make sure the fix isn't broken. Have fun!
- 1.1.1 - Added `OverridePrinterTarget` config option that ensures the activator receives printer result as long as they're valid
- 1.1.0
    - Added on-drop distribution setting
    - Made on-teleport distribution togglable
    - Reworked code structure
    - Fixed wrong code that could've lead to errors when ignoring dead players
    - Added filtering for white, green, red and boss items
    - Added separate filtering options for teleport and drop
- 1.0.2 - Added config option for ignoring lunar items
- 1.0.1 - Added website url
- 1.0.0 - Initial release